
%bcond_without bootstrap

Name:           javacc
Version:        7.0.12
Release:    1%{?dist}
Summary:        A parser/scanner generator for java

License:        BSD-3-Clause AND BSD-2-Clause
URL:            https://javacc.org/
Source0:        https://github.com/javacc/javacc/archive/%{name}-%{version}.tar.gz
Patch0:         0001-Fix-javadoc-errors-in-JavaCharStream.template.patch
Patch1:         0002-Remove-extraneous-Deprecated-annotations.patch

BuildRequires:  javapackages-local
BuildRequires:  ant
%if %{without bootstrap}
BuildRequires:  javacc
%endif

Requires:       javapackages-tools

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

%description
Java Compiler Compiler (JavaCC) is the most popular parser generator for use
with Java applications. A parser generator is a tool that reads a grammar
specification and converts it to a Java program that can recognize matches to
the grammar. In addition to the parser generator itself, JavaCC provides other
standard capabilities related to parser generation such as tree building (via
a tool called JJTree included with JavaCC), actions, debugging, etc.

%package manual
License:        BSD-3-Clause AND GPL-2.0-or-later AND LGPL-2.1-or-later AND (AFL-2.0 OR BSD-3-Clause) AND ISC
Summary:        Manual for %{name}

%description manual
Manual for %{name}.

%package demo
Summary:        Examples for %{name}
Requires:       %{name} = %{version}-%{release}

%description demo
Examples for %{name}.

%javadoc_package

%prep
%autosetup -n %{name}-%{name}-%{version} -p1

%if %{without bootstrap}
find . -name "*.jar" -delete
%endif
find examples -name .gitignore -delete

fixtimestamp() {
  touch -r $1.orig $1
  rm $1.orig
}

mv examples/JJTreeExamples/cpp/README examples/JJTreeExamples/cpp/README.orig
iconv -f WINDOWS-1252 -t UTF-8 examples/JJTreeExamples/cpp/README.orig > \
  examples/JJTreeExamples/cpp/README
fixtimestamp examples/JJTreeExamples/cpp/README

sed -i.orig 's/\r//' examples/JJTreeExamples/cpp/eg3.jjt
fixtimestamp examples/JJTreeExamples/cpp/eg3.jjt

%build
%if %{without bootstrap}
build-jar-repository -p bootstrap javacc
%endif

ant jar javadoc -Dant.build.javac.source=1.8 -Dant.build.javac.target=1.8

%mvn_artifact --skip-dependencies pom.xml target/javacc.jar

%install
%mvn_file : %{name}

%mvn_install -J target/javadoc

%jpackage_script javacc '' '' javacc javacc true
ln -s %{_bindir}/javacc %{buildroot}%{_bindir}/javacc.sh
%jpackage_script jjdoc '' '' javacc jjdoc true
%jpackage_script jjtree '' '' javacc jjtree true

rm %{buildroot}%{_bindir}/javacc.sh
ln -s javacc %{buildroot}%{_bindir}/javacc.sh

%files -f .mfiles
%license LICENSE
%doc README.md
%{_bindir}/javacc
%{_bindir}/javacc.sh
%{_bindir}/jjdoc
%{_bindir}/jjtree

%files manual
%doc docs/*

%files demo
%doc examples

%changelog
* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.0.12-1
- initial build
